// FILENAME:	Proving_Grounds.cs
//
// AUTHOR:  	NSDF Apocalypse
//------------------------------------------------------------------------------

$missionName = "The Proving Grounds";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

//Globals

$ApocDead = true;
$GorgonDead = true;
$ExecDead = true;
$GoadDead = true;
$OlyDead = true;

function setRules()
{
      %rules = "<F2>GAME TYPE: \n<F0>Proving Grounds\n\n"   @        
               "<tIDMULT_TDM_MAPNAME>"    @ 
               $missionName               @
               "\n\n<F2>RULES/OBJECTIVES:\n" @
               "<F0>1) Destroy Enemy Agressor Drones.\n\n" @
               "<tIDMULT_TDM_SCORING_1>"  @
               "<F0>Destroying a drone is worth <F3>3<F0> points.\n\n" @
               "<F0>Getting killed by a drone costs <F3>2<F0> points.\n\n" @
               "<tIDMULT_TDM_SCORING_6>"  @
               "<tIDMULT_STD_ITEMS>"      @
               "<F5>Enemy drones do not mount seeking weapons or their countermeasures! The use of seeking weapons will make destroying them rather easy, but is by no means prohibited.\n " ;

   setGameInfo(%rules);      
}

// setup the rules
// this has to be called after the definition of setRules
setRules();

//-----------------------------------------------------------------------------

Pilot Drone
{
   id = 28;
   
   name = "Aggressor Drone";

   skill = 1.0;
   accuracy = 1.0;
   aggressiveness = 1.0;
   activateDist = 900.0;
   deactivateBuff = 0.0;
   targetFreq = 0.2;
   trackFreq = 3.0;
   fireFreq = 0.15;
   LOSFreq = 0.8;
   orderFreq = 2.0;
};

//-----------------------------------------------------------------------------

function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = True;	

	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

	$server::disableTeamRed = false;
	$server::disableTeamBlue = true;
	$server::disableTeamYellow = false;
	$server::disableTeamPurple = true;
}

function onMissionLoad()
{
   cdAudioCycle("Newtech", "Mechsoul", "Gnash"); 

	// get the original ID for each AI Herc ( for use later when we clone them )
	$Apoc1 = getObjectId( "MissionGroup/AI/Apocalypse/Apoc1" );
	$Apoc2 = getObjectId( "MissionGroup/AI/Apocalypse/Apoc2" );
	$Gorgon1 = getObjectId( "MissionGroup/AI/Gorgon/Gorgon1" );
	$Exec1 = getObjectId( "MissionGroup/AI/Executioner/Exec1" );
	$Goad1 = getObjectId( "MissionGroup/AI/Goad/Goad1" );
	$Oly1 = getObjectId( "MissionGroup/AI/Olympian/Oly1" );
	$Nav1 = getObjectId( "MissionGroup/NavPoints/NavApoc" );
	$Nav2 = getObjectId( "MissionGroup/NavPoints/NavGorgon" );
	$Nav3 = getObjectId( "MissionGroup/NavPoints/NavExec" );
	$Nav4 = getObjectId( "MissionGroup/NavPoints/NavGoad" );
	$Nav5 = getObjectId( "MissionGroup/NavPoints/NavOly" );

}

function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
 	$padWaitTime = 30;
}

function player::onAdd(%this)
{
   player::onAddLog(%this);
		
      say(%this,0, strcat("<F1>Welcome to the Proving Grounds, ", getName(%this), "! Agressor Drones can be spawned from Nav Alpha. "));	      }

// ZenAll Pad Functionality
//------------------------------------------------------------------------------
function ZenAll::trigger::onEnter(%this, %object)
{
   // tell user pad has been entered
   Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}

function ZenAll::trigger::onContact(%this, %object)
{
   // two hundred points of repair
   // ten percent reloading
   Zen::work(%this, %object, 200, 10, 0, true); 
}

function ZenAll::trigger::onLeave(%this, %object)
{
   Zen::onLeave(%this, %object); 
}

// AI Respawn Code
//------------------------------------------------------------------------------
function ApocRespawn::structure::onAttacked(%this, %attacker)
{
	// See if attacker is a player
	if(%attacker != $Apoc1)
	if(%attacker != $Apoc2)
	if(%attacker != $Gorgon1)
	if(%attacker != $Exec1)
	if(%attacker != $Goad1)
	if(%attacker != $Oly1)
	{
		// Check if an AI already exists
		if( $ApocDead == true )
		{
			say(0,1,"Spawning New Apocalypse Agressor at Nav001");

			setNavMarker($Nav1, true, %attacker);

			%ApocNum = randomInt( 1, 2 );

			if(%ApocNum == 1)
			{
				setPosition($Apoc1, 2300, 950, 100);

				$ApocDead = false;
			}
			if(%ApocNum == 2)
			{
				setPosition($Apoc2, 2300, 950, 100);

				$ApocDead = false;
			}
		}
		else
		{
			say(0,1,"An Apocalypse Agressor is Still Alive");
		}
	}
	else
	{
	}

}

function GorgonRespawn::structure::onAttacked(%this, %attacker)
{
	// See if attacker is a player
	if(%attacker != $Apoc1)
	if(%attacker != $Apoc2)
	if(%attacker != $Gorgon1)
	if(%attacker != $Exec1)
	if(%attacker != $Goad1)
	if(%attacker != $Oly1)
	{
		// Check if an AI already exists
		if( $GorgonDead == true )
		{
			say(0,1,"Spawning New Gorgon Agressor at Nav002");

			setPosition($Gorgon1, 2755, 1975, 100);

			setNavMarker($Nav2, true, %attacker);

			$GorgonDead = false;
		}
		else
		{
		say(0,1,"A Gorgon Agressor is Still Alive");
		}

	}
}

function ExecRespawn::structure::onAttacked(%this, %attacker)
{
	// See if attacker is a player
	if(%attacker != $Apoc1)
	if(%attacker != $Apoc2)
	if(%attacker != $Gorgon1)
	if(%attacker != $Exec1)
	if(%attacker != $Goad1)
	if(%attacker != $Oly1)
	{
		// Check if an AI already exists
		if( $ExecDead == true )
		{
			say(0,1,"Spawning New Executioner Agressor at Nav003");

			setPosition($Exec1, 2975, 1240, 100);

			setNavMarker($Nav3, true, %attacker);

			$ExecDead = false;
		}
		else
		{
		say(0,1,"An Executioner Agressor is Still Alive");
		}

	}
}

function GoadRespawn::structure::onAttacked(%this, %attacker)
{
	// See if attacker is a player
	if(%attacker != $Apoc1)
	if(%attacker != $Apoc2)
	if(%attacker != $Gorgon1)
	if(%attacker != $Exec1)
	if(%attacker != $Goad1)
	if(%attacker != $Oly1)
	{
		// Check if an AI already exists
		if( $GoadDead == true )
		{
			say(0,1,"Spawning New Goad Agressor at Nav004");

			setPosition($Goad1, 2020, 1735, 100);

			setNavMarker($Nav4, true, %attacker);

			$GoadDead = false;
		}
		else
		{
		say(0,1,"A Goad Agressor is Still Alive");
		}

	}
}

function OlyRespawn::structure::onAttacked(%this, %attacker)
{
	// See if attacker is a player
	if(%attacker != $Apoc1)
	if(%attacker != $Apoc2)
	if(%attacker != $Gorgon1)
	if(%attacker != $Exec1)
	if(%attacker != $Goad1)
	if(%attacker != $Oly1)
	{
		// Check if an AI already exists
		if( $OlyDead == true )
		{
			say(0,1,"Spawning New Olympian Agressor at Nav005");

			setPosition($Oly1, 1095, 1355, 197);

			setNavMarker($Nav5, true, %attacker);

			$OlyDead = false;
		}
		else
		{
		say(0,1,"An Olympian Agressor is Still Alive");
		}

	}
}

// If an AI herc dies, re-clone/drop them
//-----------------------------------------------------------------------------
function vehicle::onDestroyed( %this, %destroyer )
{
   // give the death messages...
   if(%this != $Apoc1)
   if(%this != $Apoc2)
   if(%this != $Gorgon1)
   if(%this != $Exec1)
   if(%this != $Goad1)
   if(%this != $Oly1)
   {
	%message = getFancyDeathMessage(getHUDName(%this), getHUDName(%destroyer));
	if(%message != "")
	{
	   say( 0, 0, %message);
	}
   }
   //Check for an AI Herc
   if( %this == $Apoc1 )
   {
	say(0,1,"Apocalypse Agressor Destroyed!");

	schedule( "trevorsCloneVehicle(\"$Apoc1\", " @ %this @ ", 10920, 9185, 50);", $respawnNoDelay);

	$ApocDead = true;
   }
   if( %this == $Apoc2 )
   {
	say(0,1,"Apocalypse Agressor Destroyed!");

	schedule( "trevorsCloneVehicle(\"$Apoc2\", " @ %this @ ", 10865, 9180, 50);", $respawnNoDelay);

	$ApocDead = true;
   }

   if( %this == $Gorgon1 )
   {
	say(0,1,"Gorgon Agressor Destroyed!");

	schedule( "trevorsCloneVehicle(\"$Gorgon1\", " @ %this @ ", 10945, 9235, 50);", $respawnNoDelay);

	$GorgonDead = true;
   }

   if( %this == $Exec1 )
   {
	say(0,1,"Executioner Agressor Destroyed!");

	schedule( "trevorsCloneVehicle(\"$Exec1\", " @ %this @ ", 10825, 9180, 50);", $respawnNoDelay);

	$ExecDead = true;
   }

   if( %this == $Goad1 )
   {
	say(0,1,"Goad Agressor Destroyed!");

	schedule( "trevorsCloneVehicle(\"$Goad1\", " @ %this @ ", 10840, 9245, 50);", $respawnNoDelay);

	$GoadDead = true;
   }

   if( %this == $Oly1 )
   {
	say(0,1,"Olympian Agressor Destroyed!");

	schedule( "trevorsCloneVehicle(\"$Oly1\", " @ %this @ ", 11000, 9200, 50);", $respawnNoDelay);

	$OlyDead = true;
   }

   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%this, %destroyer);
   
   // rules enforcement
   if(
      (getTeam(%this) == getTeam(%destroyer)) &&
      (%this != %destroyer)
   )
   {
      antiTeamKill(%destroyer);
   }
}


// AI Clone Function
//-----------------------------------------------------------------------------
function trevorsCloneVehicle(%globalVarName, %old, %x, %y, %z)
{
   %clone = cloneVehicle(%old);
   setPosition(%clone, %x, %y, %z);

   schedule( "deleteObject(" @ %old @ ");", 10 );

   schedule( %globalVarName @ " = " @ %clone @ ";", 0);

   addToSet( "MissionGroup", %clone );

   %path = %globalVarName @ "Path";
   schedule( "order( " @ %clone @ ", guard, " @ %path @ " );", 1 );
}
